package cn.zgfxrc.boot;

import cn.xuyanwu.spring.file.storage.EnableFileStorage;
import org.mybatis.spring.annotation.MapperScan;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.cloud.openfeign.EnableFeignClients;
import org.springframework.scheduling.annotation.EnableAsync;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @author huanghs
 * @date 2022.8.22
 */
@EnableAsync
@EnableFileStorage
@EnableScheduling
@EnableFeignClients(basePackages = {"cn.zgfxrc", "com.rsjst"})
@MapperScan({"cn.zgfxrc.**.mapper", "com.rsjst.**.mapper"})
@SpringBootApplication(scanBasePackages = {"cn.zgfxrc", "com.rsjst"})
@RestController
public class FxBootApplication {
  public static void main(String[] args) {
    SpringApplication.run(FxBootApplication.class, args);
  }

  @PostMapping("health")
  public String health() {
    return "UP";
  }
}
