package cn.zgfxrc.boot.common.config.mybatis;

import com.baomidou.mybatisplus.core.handlers.MetaObjectHandler;
import com.seepine.secret.AuthUtil;
import com.seepine.secret.entity.AuthUser;
import com.seepine.secret.exception.SecretException;
import java.time.LocalDateTime;
import org.apache.ibatis.reflection.MetaObject;
import org.springframework.stereotype.Component;

/**
 * @author huanghs@zgfxrc.cn
 * @date 2021.11.1
 */
@Component
public class BaseModalMetaObjectHandler implements MetaObjectHandler {
  private static final String CREATE_ID = "createId";
  private static final String UPDATE_ID = "updateId";
  /** 用来保存姓名 */
  private static final String CREATE_NAME = "createName";

  private static final String UPDATE_NAME = "updateName";

  private static final String CREATE_TIME = "createTime";
  private static final String UPDATE_TIME = "updateTime";
  private static final String IS_DELETE = "isDelete";
  private static final String IS_SYSTEM = "isSystem";
  private static final String IS_LOCK = "isLock";

  @Override
  public void insertFill(MetaObject metaObject) {
    // 初始化是否删除
    setField(metaObject, IS_DELETE, false);
    // 初始化是否系统内置
    setField(metaObject, IS_SYSTEM, false);
    // 初始化是否锁定
    setField(metaObject, IS_LOCK, false);
    // 设置创建时间
    setField(metaObject, CREATE_TIME, LocalDateTime.now());
    try {
      AuthUser user = AuthUtil.getUser();
      setField(metaObject, CREATE_ID, user.getIdAsLong());
      setField(metaObject, CREATE_NAME, user.getFullName());
    } catch (SecretException ignored) {
    }
  }

  @Override
  public void updateFill(MetaObject metaObject) {
    // 设置更新时间
    setField(metaObject, UPDATE_TIME, LocalDateTime.now());
    try {
      AuthUser user = AuthUtil.getUser();
      setField(metaObject, UPDATE_ID, user.getIdAsLong());
      setField(metaObject, UPDATE_NAME, user.getFullName());
    } catch (SecretException ignored) {
    }
  }

  void setField(MetaObject metaObject, String fieldName, Object fieldVal) {
    if (this.getFieldValByName(fieldName, metaObject) == null && fieldVal != null) {
      this.setFieldValByName(fieldName, fieldVal, metaObject);
    }
  }
}
