package cn.zgfxrc.boot.common.config.mybatis;

import cn.zgfxrc.boot.common.mybatis.tenant.interceptor.TenantFilterService;
import com.seepine.secret.AuthUtil;
import com.seepine.secret.entity.AuthUser;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import org.springframework.lang.NonNull;
import org.springframework.stereotype.Component;

/**
 * 默认租户id获取
 *
 * @author huanghs
 */
@Component
public class TenantFilterServiceImpl implements TenantFilterService {
  private static final long DEFAULT_TENANT_ID = -1L;
  private static final String INNER_KEY = "inner";
  private static final String INNER_VALUE = "true";
  private static final String TENANT_KEY = "tenantId";

  @Override
  @NonNull
  public Object fill(
      @NonNull ServletRequest servletRequest, @NonNull ServletResponse servletResponse) {
    try {
      try {
        HttpServletRequest request = (HttpServletRequest) servletRequest;
        String inner = request.getHeader(INNER_KEY);
        if (INNER_VALUE.equals(inner)) {
          String tenantId = request.getHeader(TENANT_KEY);
          if (tenantId != null) {
            return tenantId;
          }
        }
      } catch (Exception ignored) {
      }
      AuthUser user = AuthUtil.getUser();
      return user.getTenantId() == null ? DEFAULT_TENANT_ID : user.getTenantId();
    } catch (Exception e) {
      return DEFAULT_TENANT_ID;
    }
  }
}
