## 说明

此包定义了常见接口需要校验的情况，例如新增时需要校验名称不能为空，编辑时名称可为空但主键id不能为空， 此时就需要通过分组校验实现

### 1. 实体类添加校验规则

```java
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;

class User {

  @NotNull(message = "主键id不能为空", groups = EditGroup.class)
  Long id;

  @NotBlank(message = "名称不能为空", groups = AddGroup.class)
  String name;
}
```

### 2. 接口添加校验注解

```java
import io.swagger.v3.oas.annotations.parameters.RequestBody;
import org.springframework.validation.annotation.Validated;

class Controller {

  @RequestMapping("add")
  public void add(@RequestBody @Validated(AddGroup.class) User entity) {
    // service.add(entity);
  }

  @RequestMapping("edit")
  public void edit(@RequestBody @Validated(EditGroup.class) User entity) {
    // service.edit(entity);
  }
}
```
