package cn.zgfxrc.boot.common.core.enums;

import com.baomidou.mybatisplus.annotation.IEnum;
import com.fasterxml.jackson.annotation.JsonCreator;
import lombok.AllArgsConstructor;

/**
 * 拖拽类型
 *
 * @author huanghs@zgfxrc.cn
 * @date 2022.12.2
 */
@AllArgsConstructor
public enum DropPosition implements IEnum<Integer> {
  /** 拖拽类型 */
  UPPER(-1, "dropNode的上方"),
  INNER(0, "drop内"),
  BELOW(1, "dropNode的下方");

  private final Integer value;
  private final String label;

  @Override
  public Integer getValue() {
    return this.value;
  }

  @Override
  public String toString() {
    return value.toString();
  }

  @JsonCreator
  static DropPosition jsonCreator(Object data) {
    String str = data.toString();
    for (DropPosition item : DropPosition.values()) {
      if (item.getValue().toString().equals(str) || item.name().equals(str)) {
        return item;
      }
    }
    return null;
  }
}
