package cn.zgfxrc.boot.common.core.util;

import java.time.LocalDate;
import java.time.format.DateTimeFormatter;

/**
 * @author huanghs
 * @date 2022.7.11
 */
public class LocalDateUtil {
  private static final DateTimeFormatter DF = DateTimeFormatter.ofPattern("yyyy-MM-dd");
  /**
   * 判断a是否小于b
   *
   * @param a 2022-7-11
   * @param b 2022-7-12
   * @return bool
   */
  public static boolean isLt(LocalDate a, LocalDate b) {
    return a.isBefore(b);
  }
  /**
   * 判断a是否小于b
   *
   * @param a 2022-7-11
   * @param b 2022-7-12
   * @return bool
   */
  public static boolean isLe(LocalDate a, LocalDate b) {
    return isLt(a, b) || a.equals(b);
  }

  /**
   * 判断a是否大于b
   *
   * @param a 2022-7-11
   * @param b 2022-7-12
   * @return bool
   */
  public static boolean isGt(LocalDate a, LocalDate b) {
    return a.isAfter(b);
  }
  /**
   * 判断a是否大于b
   *
   * @param a 2022-7-11
   * @param b 2022-7-12
   * @return bool
   */
  public static boolean isGe(LocalDate a, LocalDate b) {
    return isGt(a, b) || a.equals(b);
  }

  public static String format(LocalDate date) {
    return date.format(DF);
  }
}
