package cn.zgfxrc.boot.common.mybatis.tenant.interceptor.config;

import cn.zgfxrc.boot.common.mybatis.AutoConfiguration;
import cn.zgfxrc.boot.common.mybatis.properties.TenantProperties;
import cn.zgfxrc.boot.common.mybatis.tenant.interceptor.TenantFilterService;
import cn.zgfxrc.boot.common.mybatis.tenant.interceptor.impl.MybatisTenantServiceImpl;
import javax.annotation.Resource;
import lombok.extern.slf4j.Slf4j;
import org.springframework.boot.autoconfigure.AutoConfigureAfter;
import org.springframework.boot.autoconfigure.condition.ConditionalOnMissingBean;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * @author seepine
 * @since 0.1.0
 */
@Slf4j
@Configuration
@AutoConfigureAfter(AutoConfiguration.class)
public class TenantServiceConfiguration {

  @Resource private TenantProperties tenantProperties;

  @Bean
  @ConditionalOnMissingBean(TenantFilterService.class)
  public TenantFilterService tenantFilterService() {
    return new MybatisTenantServiceImpl(tenantProperties);
  }
}
