package com.rsjst.hcm.recruit.biz.service;

import cn.zgfxrc.boot.common.core.entity.base.BaseModel;
import cn.zgfxrc.boot.common.core.util.PageUtil;
import cn.zgfxrc.boot.upms.api.feign.RemoteUserService;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.rsjst.hcm.recruit.api.entity.RecruitResume;
import com.rsjst.hcm.recruit.api.entity.res.RecruitResumeRes;
import com.rsjst.hcm.recruit.biz.mapper.RecruitResumeMapper;
import com.seepine.tool.Run;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Service;

/**
 * @author huanghs@zgfxrc.cn
 * @date 2022.8.22
 */
@Slf4j
@Service
@AllArgsConstructor
public class RecruitResumeService extends ServiceImpl<RecruitResumeMapper, RecruitResume> {
  private final RemoteUserService remoteUserService;

  public IPage<RecruitResumeRes> pageRes(Page<RecruitResume> page, RecruitResume entity) {
    LambdaQueryWrapper<RecruitResume> wrapper = Wrappers.lambdaQuery(entity);
    return PageUtil.convertPage(
        super.page(page, wrapper),
        item -> {
          RecruitResumeRes res = new RecruitResumeRes();
          BeanUtils.copyProperties(item, res);
          Run.nonEmpty(
              remoteUserService.get(res.getCreateId()),
              user -> res.setCreatePhone(user.getPhone()));
          return res;
        });
  }

  @Override
  public boolean updateById(RecruitResume entity) {
    return super.update(
        entity,
        Wrappers.<RecruitResume>lambdaUpdate()
            .eq(BaseModel::getId, entity.getId())
            // 重写updateById，实现附件为null时，也更新数据库
            .set(RecruitResume::getFiles, entity.getFiles()));
  }
}
