package cn.zgfxrc.boot.upms.api.dto;

import cn.zgfxrc.boot.common.core.entity.interfaces.AddGroup;
import cn.zgfxrc.boot.upms.api.enums.NotifyChannelType;
import lombok.*;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;

/**
 * @author huanghs
 * @date 2022.7.27
 */
@Getter
@Builder
@ToString
@NoArgsConstructor
@AllArgsConstructor
public class NotifyDto {
  @NotNull(message = "类型不能为空", groups = AddGroup.class)
  NotifyChannelType type;

  @NotBlank(message = "接收人不能为空", groups = AddGroup.class)
  String to;

  @NotBlank(message = "标题不能为空", groups = AddGroup.class)
  String title;

  @NotBlank(message = "内容不能为空", groups = AddGroup.class)
  String content;
}
