package cn.zgfxrc.boot.upms.api.entity;

import cn.zgfxrc.boot.common.core.entity.base.BaseModelWithTenant;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * @author huanghs@zgfxrc.cn
 * @date 2022.12.1
 */
@Data
@ApiModel("字典项")
@EqualsAndHashCode(callSuper = true)
public class SysDictItem extends BaseModelWithTenant<SysDictItem> {
  @ApiModelProperty("字典id")
  Long dictId;

  @ApiModelProperty("字典标签")
  String label;

  @ApiModelProperty("字典值")
  String value;

  @ApiModelProperty("描述")
  String description;

  @ApiModelProperty("是否禁用")
  Boolean disabled;

  @ApiModelProperty("是否可编辑，当字典为默认字典时可配置此值，若否则租户初始化字典后，该项将无法修改和删除和禁用")
  Boolean editable;

  @ApiModelProperty("排序值")
  Integer sort;
}
