package cn.zgfxrc.boot.upms.api.entity;

import cn.zgfxrc.boot.common.core.entity.base.BaseModel;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * 文件存储记录，方便迁移，也方便查看所记录文件
 *
 * @author huanghs@zgfxrc.cn
 * @date 2021.11.5
 */
@Data
@ApiModel("文件存储")
@EqualsAndHashCode(callSuper = true)
public class SysFile extends BaseModel<SysFile> {

  @ApiModelProperty("文件地址")
  String url;

  @ApiModelProperty("文件大小")
  Long size;

  @ApiModelProperty("OSS文件名")
  String filename;

  @ApiModelProperty("原文件名")
  String originalFilename;

  @ApiModelProperty("扩展")
  String ext;

  @ApiModelProperty("基础路径")
  String basePath;

  @ApiModelProperty("路径")
  String path;

  @ApiModelProperty("存储平台")
  String platform;

  @ApiModelProperty("缩略图url")
  String thUrl;

  @ApiModelProperty("缩略图文件名")
  String thFilename;

  @ApiModelProperty("缩略图文件大小")
  Long thSize;

  @ApiModelProperty("缩略图MIME类型")
  String thContentType;

  @ApiModelProperty("文件所属对象id,业务id")
  String objectId;

  @ApiModelProperty("文件所属对象类型，例如用户头像，评价图片")
  String objectType;
}
