package cn.zgfxrc.boot.upms.api.entity;

import cn.zgfxrc.boot.common.core.entity.base.BaseModel;
import cn.zgfxrc.boot.common.core.enums.MenuType;
import cn.zgfxrc.boot.common.core.enums.PlatformType;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;

/**
 * @author huanghs@zgfxrc.cn
 * @date 2021.11.2
 */
@Data
@ApiModel("平台用户")
@EqualsAndHashCode(callSuper = true)
public class SysMenu extends BaseModel<SysMenu> {

  @NotBlank(message = "名称不能为空")
  @ApiModelProperty("菜单名称")
  String name;

  @ApiModelProperty("图标")
  String icon;

  @ApiModelProperty("菜单路径")
  String path;

  @ApiModelProperty("按钮权限值")
  String permission;

  @NotNull(message = "菜单类型不能为空")
  @ApiModelProperty("菜单类型")
  MenuType menuType;

  @NotNull(message = "平台类型不能为空")
  @ApiModelProperty("平台类型")
  PlatformType platformType;

  @ApiModelProperty("是否路由缓冲")
  Boolean isKeepAlive;

  @ApiModelProperty("排序值")
  Integer sort;

  @ApiModelProperty("父id")
  Long parentId;
}
