package cn.zgfxrc.boot.upms.api.entity;

import cn.zgfxrc.boot.common.core.entity.base.BaseModelWithTenant;
import cn.zgfxrc.boot.common.core.enums.ActiveStatus;
import cn.zgfxrc.boot.common.core.enums.PlatformType;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * @author huanghs@zgfxrc.cn
 * @date 2021.11.2
 */
@Data
@ApiModel("用户")
@EqualsAndHashCode(callSuper = true)
public class SysUser extends BaseModelWithTenant<SysUser> {
  @ApiModelProperty("手机号")
  String phone;

  @ApiModelProperty("电子邮件")
  String email;

  @ApiModelProperty("密码")
  String password;

  @ApiModelProperty("头像")
  String avatarUrl;

  @ApiModelProperty("姓名")
  String fullName;

  @ApiModelProperty("直属负责人id")
  Long leaderId;

  @ApiModelProperty("是否系统内置")
  Boolean isSystem;

  @ApiModelProperty("平台类型")
  PlatformType platformType;

  @ApiModelProperty("活动状态")
  ActiveStatus status;
}
