package cn.zgfxrc.boot.upms.api.enums;

import com.baomidou.mybatisplus.annotation.IEnum;
import com.fasterxml.jackson.annotation.JsonCreator;
import lombok.AllArgsConstructor;
import org.springframework.lang.NonNull;

/**
 * @author huanghs@zgfxrc.cn
 * @date 2022.12.2
 */
@AllArgsConstructor
public enum DeptType implements IEnum<String> {
  /** 候选人状态状态 */
  TENANT("tenant", "租户"),
  DEPT("dept", "部门");

  public final String value;
  public final String label;

  @Override
  public String getValue() {
    return this.value;
  }

  @Override
  public String toString() {
    return value;
  }

  @JsonCreator
  static DeptUserType jsonCreator(@NonNull Object data) {
    String str = data.toString();
    for (DeptUserType item : DeptUserType.values()) {
      if (item.getValue().equals(str) || item.name().equals(str)) {
        return item;
      }
    }
    return null;
  }
}
