package cn.zgfxrc.boot.upms.api.enums;

import com.baomidou.mybatisplus.annotation.IEnum;
import com.fasterxml.jackson.annotation.JsonCreator;
import lombok.AllArgsConstructor;
import org.springframework.lang.NonNull;

/**
 * @author huanghs@zgfxrc.cn
 */
@AllArgsConstructor
public enum GroupUserType implements IEnum<String> {
  /** 候选人状态状态 */
  NORMAL("normal", "普通成员"),
  PRIMARY("primary", "主负责人"),
  SECONDARY("secondary", "次负责人");

  public final String value;
  public final String label;

  @Override
  public String getValue() {
    return this.value;
  }

  @Override
  public String toString() {
    return value;
  }

  @JsonCreator
  static GroupUserType jsonCreator(@NonNull Object data) {
    String str = data.toString();
    for (GroupUserType item : GroupUserType.values()) {
      if (item.getValue().equals(str) || item.name().equals(str)) {
        return item;
      }
    }
    return null;
  }
}
