package cn.zgfxrc.boot.upms.api.enums;

import com.baomidou.mybatisplus.annotation.IEnum;
import com.fasterxml.jackson.annotation.JsonCreator;
import lombok.AllArgsConstructor;
import org.springframework.lang.NonNull;

/**
 * @author huanghs@zgfxrc.cn
 * @date 2022.6.30
 */
@AllArgsConstructor
public enum NotifyChannelType implements IEnum<String> {
  /** 候选人状态状态 */
  MAIL("mail", "邮箱"),
  DING("ding", "钉钉"),
  WE_CHAT("wechat", "企业微信");

  public final String value;
  public final String label;

  @Override
  public String getValue() {
    return this.value;
  }

  @Override
  public String toString() {
    return value;
  }

  @JsonCreator
  static NotifyChannelType jsonCreator(@NonNull Object data) {
    String str = data.toString();
    for (NotifyChannelType item : NotifyChannelType.values()) {
      if (item.getValue().equals(str) || item.name().equals(str)) {
        return item;
      }
    }
    return null;
  }
}
