package cn.zgfxrc.boot.upms.biz.controller;

import cn.zgfxrc.boot.common.core.entity.interfaces.AddGroup;
import cn.zgfxrc.boot.upms.api.entity.SysNotifyChannel;
import cn.zgfxrc.boot.upms.biz.service.SysNotifyChannelService;
import cn.zgfxrc.boot.upms.biz.util.SecureUtil;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.node.ObjectNode;
import com.seepine.json.Json;
import io.swagger.annotations.Api;
import lombok.AllArgsConstructor;
import org.springframework.util.StringUtils;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @author huanghs@zgfxrc.cn
 * @date 2022.7.25
 */
@RestController
@Api(tags = "消息通知通道管理")
@RequestMapping("sys/notify/channel")
@AllArgsConstructor
public class SysNotifyChannelController {
  private final SysNotifyChannelService sysNotifyChannelService;

  @PostMapping("get/config")
  public JsonNode get() {
    ObjectNode objectNode = Json.objectNode();
    for (SysNotifyChannel sysNotifyChannel : sysNotifyChannelService.list()) {
      objectNode.set(
          sysNotifyChannel.getType().value,
          StringUtils.hasText(sysNotifyChannel.getConfig())
              ? Json.parse(SecureUtil.decodeAes(sysNotifyChannel.getConfig()))
              : null);
    }
    return objectNode;
  }

  @PostMapping("edit/config")
  public void edit(@RequestBody @Validated(AddGroup.class) SysNotifyChannel channel) {
    sysNotifyChannelService.edit(channel);
  }
}
