package cn.zgfxrc.boot.upms.biz.mapper;

import cn.zgfxrc.boot.common.mybatis.base.MpBaseMapper;
import cn.zgfxrc.boot.upms.api.entity.SysGroupUser;
import cn.zgfxrc.boot.upms.api.enums.GroupUserType;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;

/**
 * @author huanghs@zgafxrc.cn
 */
@Mapper
public interface SysGroupUserMapper extends MpBaseMapper<SysGroupUser> {

  default List<SysGroupUser> list(Long groupId, GroupUserType type) {
    return lambdaQuery()
        .eq(SysGroupUser::getGroupId, groupId)
        .eq(SysGroupUser::getType, type)
        .list();
  }

  default List<SysGroupUser> listPrimary(Long groupId) {
    return list(groupId, GroupUserType.PRIMARY);
  }

  default List<SysGroupUser> listSecondary(Long groupId) {
    return list(groupId, GroupUserType.SECONDARY);
  }
}
