package cn.zgfxrc.boot.upms.biz.service;

import cn.hutool.core.bean.BeanUtil;
import cn.xuyanwu.spring.file.storage.FileInfo;
import cn.xuyanwu.spring.file.storage.recorder.FileRecorder;
import cn.zgfxrc.boot.upms.api.entity.SysFile;
import cn.zgfxrc.boot.upms.biz.mapper.SysFileMapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

/**
 * @author huanghs@zgfxrc.cn
 * @date 2021.11.2
 */
@Slf4j
@Service
@AllArgsConstructor
public class SysFileService extends ServiceImpl<SysFileMapper, SysFile> implements FileRecorder {

  @Override
  public boolean record(FileInfo info) {
    SysFile sysFile = BeanUtil.copyProperties(info, SysFile.class);
    if (!save(sysFile)) {
      return false;
    }
    info.setUrl("/webapi/sys/file/get/" + info.getFilename());
    return true;
  }

  @Override
  public FileInfo getByUrl(String url) {
    return BeanUtil.copyProperties(
        getOne(Wrappers.<SysFile>lambdaQuery().eq(SysFile::getUrl, url)),
        cn.xuyanwu.spring.file.storage.FileInfo.class);
  }

  @Override
  public boolean delete(String url) {
    return remove(Wrappers.<SysFile>lambdaQuery().eq(SysFile::getUrl, url));
  }

  public FileInfo getByFilename(String fileName) {
    SysFile file =
        getOne(
            Wrappers.<SysFile>lambdaQuery()
                .eq(SysFile::getFilename, fileName.replace("/webapi/sys/file/get/", "")));
    return file == null ? null : BeanUtil.copyProperties(file, FileInfo.class);
  }
}
