package cn.zgfxrc.boot.upms.biz.service;

import cn.zgfxrc.boot.upms.api.entity.SysPosition;
import cn.zgfxrc.boot.upms.api.entity.SysPositionUser;
import cn.zgfxrc.boot.upms.api.enums.PositionType;
import cn.zgfxrc.boot.upms.biz.mapper.SysPositionMapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.seepine.tool.util.Objects;
import com.seepine.tool.util.Validate;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
@AllArgsConstructor
public class SysPositionService extends ServiceImpl<SysPositionMapper, SysPosition> {

  final SysPositionUserService sysPositionUserService;

  @Transactional(rollbackFor = Exception.class)
  public void savePositionUser(
      Long userId, List<Long> positionSecondaryIds, Long positionPrimaryId) {
    sysPositionUserService.lambdaUpdate().eq(SysPositionUser::getUserId, userId).remove();
    if (Objects.nonNull(positionPrimaryId)) {
      SysPositionUser positionUser = new SysPositionUser();
      positionUser.setPositionId(positionPrimaryId);
      positionUser.setType(PositionType.PRIMARY);
      positionUser.setUserId(userId);
      Validate.isTrue(sysPositionUserService.save(positionUser), "职位保存失败[1]");
    }
    if (Objects.nonEmpty(positionSecondaryIds)) {
      if (Objects.nonNull(positionPrimaryId)) {
        positionSecondaryIds =
            positionSecondaryIds.stream().filter(item -> !item.equals(positionPrimaryId)).toList();
      }
      if (Objects.isEmpty(positionSecondaryIds)) {
        return;
      }
      List<SysPositionUser> positionUserList =
          positionSecondaryIds.stream()
              .map(
                  item -> {
                    SysPositionUser positionUser = new SysPositionUser();
                    positionUser.setPositionId(item);
                    positionUser.setType(PositionType.SECONDARY);
                    positionUser.setUserId(userId);
                    return positionUser;
                  })
              .toList();
      Validate.isTrue(sysPositionUserService.saveBatch(positionUserList), "职位保存失败[2]");
    }
  }
}
