package cn.zgfxrc.boot.upms.biz.util;

import cn.hutool.core.codec.Base64;
import cn.hutool.crypto.Mode;
import cn.hutool.crypto.Padding;
import cn.hutool.crypto.symmetric.AES;
import com.seepine.wrap.WrapException;

import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;
import java.nio.charset.StandardCharsets;

/**
 * 前端加密后端解密，防君子不防小人
 *
 * @author seepine
 * @date 2021.1.3 21:43
 */
public class AesUtil {
  private static final String KEY_ALGORITHM = "AES";

  private static final String SECRET_KEY = "fxboot!!fxboot!!";
  private static final String SECRET_IV = SECRET_KEY;

  public static final long SECRET_TIMEOUT = 5 * 60 * 1000;
  public static final AES AES =
      new AES(
          Mode.CBC,
          Padding.PKCS5Padding,
          new SecretKeySpec(SECRET_KEY.getBytes(), KEY_ALGORITHM),
          new IvParameterSpec(SECRET_IV.getBytes()));
  /**
   * (时间戳+明文)的加密密文解码为明文
   *
   * @param secret 加密密文（timestamp+明文）
   * @param timestamp timestamp
   * @return 明文
   * @throws WrapException Exception
   */
  public static String decrypt(String secret, Long timestamp) throws WrapException {
    if (timestamp == null) {
      throw new WrapException("接口不支持直接访问");
    }
    String result;
    try {
      result = AES.decryptStr(Base64.decode(secret.getBytes(StandardCharsets.UTF_8))).trim();
    } catch (Exception e) {
      throw new WrapException("解密失败,请重试");
    }
    if (result.startsWith(timestamp.toString())) {
      long nowTime = System.currentTimeMillis();
      if (Math.abs(nowTime - timestamp) <= SECRET_TIMEOUT) {
        return result.replace(timestamp.toString(), "");
      }
      throw new WrapException("网络超时,请重试");
    }
    throw new WrapException("网络异常,请重试");
  }
}
