package cn.zgfxrc.boot.upms.biz.util;

import cn.hutool.core.lang.Validator;
import com.seepine.tool.util.Validate;
import com.seepine.wrap.WrapException;
import org.springframework.stereotype.Component;

/**
 * @author huanghs
 * @date 2021.11.5
 */
@Component
public class ValidUtil {

  private static final String BLANK = "";

  /**
   * 检验手机号
   *
   * @param phone 手机号
   */
  public static void validPhone(String phone) {
    Validate.isTrue(Validator.isMobile(phone), "手机号格式错误");
  }

  /** 密码相关 */
  private static final int PASSWORD_MIN_LENGTH = 6;

  private static final int PASSWORD_MAX_LENGTH = 20;
  private static final String PASSWORD_RULE =
      "^(?=.*?[A-Z])(?=.*?[a-z])(?=.*?[0-9])(?=.*?[#?!@$%^&*-\\\\./]).{8,}$";

  public static void validPassword(String password) {
    validPassword(password, "密码");
  }

  public static void validPassword(String password, String label) {
    if (password == null || BLANK.equals(password)) {
      throw new WrapException(label + "不能为空");
    }
    if (password.length() < PASSWORD_MIN_LENGTH || password.length() > PASSWORD_MAX_LENGTH) {
      throw new WrapException(label + "长度在6-20个字符之间");
    }
  }
}
